function vexalarm_RW_handler(spellname, spellid, caster, target, status, eventchar)
	if vexalarm_Proclaims_checkForMyGrp(caster, nil, true) and vexalarm_Proclaims_checkInfight(nil, true) and vexalarm_data["rw"]["activate"] then
		if status or (not(status) and not(vexalarm_data["rw"]["onlyActivate"])) then
			local alarmtype = vexalarm_Proclaims_spellcheck(spellid, caster, eventchar, nil, true)
			if(alarmtype ~="" and alarmtype ~="dejavue") then
				vexalarm_RW_proclaim(alarmtype, spellname, spellid, caster, target, status)				
			end
		end
	end
end

function vexalarm_RW_proclaim(alarmtype, spell, spellid,  caster, target, status)
	local msg = vexalarm_RW_getSingleAlarm(alarmtype, spell, spellid, caster, target, status)
	if msg~="" then
		vexalarm_RW_genFulltext(alarmtype, spell, spellid, caster, target, status, msg)
	end
end

function vexalarm_RW_getSingleAlarm(alarmtype, spell, spellid, caster, target, status)
	--load custom msg
	local customalarm = ""
	local statusstring = "inactive"
	if status then statusstring = "active" end
	if 		alarmtype == "buff" 		then customalarm = vexalarm_data["rw"]["msgs"]["buff"][statusstring]
	elseif 	alarmtype == "selfbuff"	  	then customalarm = vexalarm_data["rw"]["msgs"]["selfbuff"][statusstring]
	elseif 	alarmtype == "grpbuff"	 	then customalarm = vexalarm_data["rw"]["msgs"]["grpbuff"][statusstring]
	elseif 	alarmtype == "instant" 		then customalarm = vexalarm_data["rw"]["msgs"]["instant"]
	elseif 	alarmtype == "instantself" 	then customalarm = vexalarm_data["rw"]["msgs"]["instantself"]
	end
	
	--load custom status msg
	local statustext=vexalarm_data["proclaims"]["msgs"]["status"][statusstring]
	
	-- change [spell]
	if spellid ~= nil and spell ~= nil then
		local channel = vexalarm_RW_checkChannel()
		if ((channel == "rwOverRide" or (channel == "channel" and vexalarm_data["rw"]["chattype"] == "RAID_WARNING")) and vexalarm_data["rw"]["forbidspelllinkrw"]) or vexalarm_data["rw"]["forbidspelllink"] then
			customalarm = string.gsub(customalarm, "%[spell%]", spell)
		else
			customalarm = string.gsub(customalarm, "%[spell%]", GetSpellLink(spellid))
		end
	end
	
	-- change [caster]
	if caster ~= nil then
		customalarm = string.gsub(customalarm, "%[caster%]", caster)
	end
	
	-- change [target]
	if target ~= nil then
		customalarm = string.gsub(customalarm, "%[target%]", target)
	end
	
	-- change [statustext]
	if statustext ~= nil then
		customalarm = string.gsub(customalarm, "%[status%]", statustext)
	end
	return customalarm
end

function vexalarm_RW_checkChannel()
	local channel = ""
	local inRaid = UnitInRaid("player")
	if inRaid and vexalarm_data["rw"]["channeloverride"] then
		channel = "rwOverRide"
	elseif not(inRaid) and vexalarm_data["rw"]["chattype"]=="RAID_WARNING" then
		channel = ""
	else
		channel = "channel"
	end
	
	return channel
end

function vexalarm_RW_genFulltext(alarmtype, spell, spellid, caster, target, status, msg)
	if status and vexalarm_spells_defaults[tostring(spellid)][7]~=nil then
		vexalarm_Totem_RW_new(alarmtype, spell, spellid, caster, target)
	end
	
	local channel = vexalarm_RW_checkChannel()
	if channel == "channel" then
		SendChatMessage(msg, vexalarm_data["rw"]["chattype"], nil, vexalarm_data["rw"]["channel"])
	elseif channel == "rwOverRide" then
		SendChatMessage(msg, "RAID_WARNING")
	end		
end







