
function vexalarm_Loader_LoadParamters(defaults)	
	if vexalarm_sp == nil then vexalarm_sp = {} end
	if vexalarm_p == nil then vexalarm_p = {} end
	
	if vexalarm_data == nil and vexalarm_p ~= nil and vexalarm_default_data ~= nil then
		if vexalarm_default_data["activate"] then
			if vexalarm_p[vexalarm_default_data["profile"]] ~= nil then
				vexalarm_optionTab_Profiles_profile = vexalarm_default_data["profile"]
				vexalarm_optionTab_Profiles_load("all", true)
			else
				print("|CFFFF7D0AVex Alarm|r ERROR: Could not load default profile. Default profile '"..vexalarm_default_data["profile"].."' doesn't exist.")
				print("|CFFFF7D0AVex Alarm|r ERROR: Default addon settings will loaded instead. You can still load another profile manually in the options")
			end
		end
	end
	
	vexalarm_default_data = vexalarm_Loader_checkTableContent(vexalarm_default_data_default, vexalarm_default_data, defaults)
	vexalarm_data = vexalarm_Loader_checkTableContent(vexalarm_defaults, vexalarm_data, defaults)
	vexalarm_f_data = vexalarm_Loader_checkVarTableContent(vexalarm_frame_defaults["Mainframe"], vexalarm_f_data, defaults)
	vexalarm_s = vexalarm_Loader_checkTableContent(vexalarm_spells_defaults, vexalarm_s, defaults)
	
	vexalarm_Load_checkMsgContents()
	
	if defaults then vexalarm_initialize(true) end
end

function vexalarm_Load_checkMsgContents()
	for key,val in pairs(vexalarm_data["proclaims"]["msgs"]) do
		if type(val) == "table" then
			vexalarm_data["proclaims"]["msgs"][key]["active"] = vexalarm_optionTab_MsgContent_filterTags(val["active"], key)
			vexalarm_data["proclaims"]["msgs"][key]["inactive"] = vexalarm_optionTab_MsgContent_filterTags(val["inactive"], key)
		else
			vexalarm_data["proclaims"]["msgs"][key] = vexalarm_optionTab_MsgContent_filterTags(val, key)
		end
	end
	
	for key,val in pairs(vexalarm_data["rw"]["msgs"]) do
		if type(val) == "table" then
			vexalarm_data["rw"]["msgs"][key]["active"] = vexalarm_optionTab_MsgContent_filterTags(vexalarm_optionTab_RWContent_killBadTags(val["active"]), key)
			vexalarm_data["rw"]["msgs"][key]["inactive"] = vexalarm_optionTab_MsgContent_filterTags(vexalarm_optionTab_RWContent_killBadTags(val["inactive"]), key)
		else
			vexalarm_data["rw"]["msgs"][key] = vexalarm_optionTab_MsgContent_filterTags(vexalarm_optionTab_RWContent_killBadTags(val), key)
		end
	end
end

function vexalarm_Loader_checkVarTableContent(defaults, saved, force)
	local temp = {}
	if force or saved == nil or type(saved) ~= "table" then
		temp = vexalarm_CopyTable(vexalarm_frame_defaults)
	else
		for key,val in pairs(saved) do
			temp[key] = vexalarm_Loader_checkTableContent(defaults, val, force)
		end
	end
	return temp
end

function vexalarm_Loader_checkTableContent(defaults, saved, force)
	local temp = {}
	if force or type(saved) ~= "table" then temp=defaults
	else
		for key,val in pairs(defaults) do
			if type(val) == "table" then
				temp[key] = {}
				if saved[key] == nil then
					temp[key] = val
				else
					temp[key] = vexalarm_Loader_checkTableContent(defaults[key], saved[key], force)
				end
			else
				if saved[key] == nil then
					temp[key] = val
				else
					temp[key] = saved[key]
				end
			end
		end
	end
	return temp
end