function vexalarm.panel_frame_settings()
	vexalarm_optionTab_FrameSettings_setCurrentFrame()
	return {
		type = "group",
		args = {
			grptestmode = {
				name = "Testmode",
				order=1, type ="group", dialogInline = true,
				args = {
					testmode = {
						name = "Activate",
						order=1, type = "toggle", width="full",
						set = function(info,val) vexalarm_Testmode_handler(val) end,
						get = function() return vexalarm.testmode end,
						},
					testmodeinfo = {name = "- Simulates Event outputs. The spell/spell-profile adjustments for the frames are still active.\n- Frames become movable\n- Frames and Outputpositions become recolored", type = "description", order=2},
					},
				},
			frame_space_testmode = {name ="\n", type = "description", order=2},
			
			grpoptiontabs = {
				name = "Toggle Option Tabs",
				order=3, type ="group", dialogInline = true,
				args = {
					Manager = {
						name = "Create / Delete",
						order=1, type = "execute", width="normal",
						func = function(info,val) vexalarm_optionTab_FrameSettings_toggleTab("manager") vexalarm_initialize(true) end,
						},
					Design = {
						name = "Frame",
						order=3, type = "execute", width="half",
						func = function(info,val) vexalarm_optionTab_FrameSettings_toggleTab("design") vexalarm_initialize(true) end,
						},
					Text = {
						name = "Outputs",
						order=4, type = "execute", width="half",
						func = function(info,val) vexalarm_optionTab_FrameSettings_toggleTab("text") vexalarm_initialize(true) end,
						},
					Sounds = {
						name = "Sounds",
						order=5, type = "execute", width="half",
						func = function(info,val) vexalarm_optionTab_FrameSettings_toggleTab("sounds") vexalarm_initialize(true) end,
						},
					Show = {
						name = "Show",
						order=6, type = "execute", width="half",
						func = function(info,val) vexalarm_optionTab_FrameSettings_toggleTab("show") vexalarm_initialize(true) end,
						},
					},
				},
			spaceoptiontabs = {name =" ", type = "description", order=4},
			
			manager = {
				name = "Create / Delete",
				order=10, type ="group", dialogInline = true, hidden = not(vexalarm_optionTab_FrameSettings_openTab["manager"]),
				args = {
					grpadd = {
						name = "Create Frame",
						order=1, type ="group", dialogInline = true,
						args = {
							frame_new = {
								name = "Name",
								order=1, type = "input", multiline = false, width = "double",
								set = function(info,val) vexalarm_optionTab_FrameSettings_name = val vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_name end,
								},
							space1 = {name = "", type = "description", order=2},
							frame_new_add = {
								name = "Create a new Frame",
								order=5, type = "execute",
								disabled = not(vexalarm_optionTab_General_checkName(vexalarm_optionTab_FrameSettings_name)),
								func = function(info,val) vexalarm_optionTab_FrameSettings_create() vexalarm_initialize(true) vexalarm_Testmode_delayTimer() end,
								confirm = vexalarm_f_data[vexalarm_optionTab_FrameSettings_name]~= nil,
								confirmText = "A frame with that name allready exists. Do you want to overwrite it ?",
								},
							space2 = {name = "", type = "description", order=10},
							frame_new_clone = {
								name = "Create clone of",
								order=11, type = "execute",
								disabled = not(vexalarm_optionTab_General_checkName(vexalarm_optionTab_FrameSettings_name)),
								func = function(info,val) vexalarm_optionTab_FrameSettings_clone() vexalarm_initialize(true) vexalarm_Testmode_delayTimer() end,
								confirm = vexalarm_f_data[vexalarm_optionTab_FrameSettings_name]~= nil,
								confirmText = "A frame with that name allready exists. Do you want to overwrite it ?",
								},
							frame = {
								name = "Existing Frames",
								order=12, type = "select", style = "dropdown",
								values =  vexalarm_optionTab_FrameSettings_getList(),
								disabled = not(vexalarm_optionTab_General_checkName(vexalarm_optionTab_FrameSettings_name)),
								set = function(self,key)
									vexalarm_optionTab_FrameSettings_currentframe = key
									vexalarm_initialize(true)
									end,
								get = function() return vexalarm_optionTab_FrameSettings_currentframe end,
								},
							status = {name = vexalarm_optionTab_FrameSettings_statusMsg["create"], type = "description", order=15},
							},
						},
					frame_space2 = {name =" ", type = "description", order=2},
					grpdelete = {
						name = "Delete / Rename",
						order=3, type ="group", dialogInline = true,
						args = {
							frame = {
								name = "Existing Frames",
								order=1, type = "select", style = "dropdown",
								values =  vexalarm_optionTab_FrameSettings_getList(),
								set = function(self,key)
									vexalarm_optionTab_FrameSettings_currentframe = key
									vexalarm_optionTab_FrameSettings_newname = key
									vexalarm_initialize(true)
									end,
								get = function() return vexalarm_optionTab_FrameSettings_currentframe end,
								},
							space2 = {name ="", type = "description", width="normal", order=3},
							delete = {
								name = "delete",
								order=5, type = "execute",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								func = function(info,val) vexalarm_optionTab_FrameSettings_frameDelete() vexalarm_initialize(true) vexalarm_Testmode_delayTimer() end,
								confirm = true,
								confirmText = "Do you really want to delete this frame?",
								},
							status = {name = vexalarm_optionTab_FrameSettings_statusMsg["delete"], type = "description", order=6},
							newname = {
								name = "New name",
								order=11, type = "input", multiline = false, width="double",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_optionTab_FrameSettings_newname = val vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_newname end,
								},
							changename = {
								name = "change Name",
								order=12, type = "execute",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe) or vexalarm_optionTab_FrameSettings_newname=="",
								func = function(info,val) vexalarm_optionTab_FrameSettings_rename() vexalarm_initialize(true) vexalarm_Testmode_delayTimer() end,
								confirm = vexalarm_f_data[vexalarm_optionTab_FrameSettings_newname]~= nil,
								confirmText = "A frame with the new name allready exists. Do you want to overwrite it ?",
								},
							status2 = {name = vexalarm_optionTab_FrameSettings_statusMsg["rename"], type = "description", order=13},
							},
						},
					},
				},
				
				
			
			design = {
				name = "Frame",
				order=30, type ="group", dialogInline = true, hidden = not(vexalarm_optionTab_FrameSettings_openTab["design"]),
				args = {
					frame = {
						name = "Frame to edit",
						order=1, type = "select", style = "dropdown",
						values =  vexalarm_optionTab_FrameSettings_getList(),
						set = function(self,key)
							vexalarm_optionTab_FrameSettings_currentframe = key
							vexalarm_optionTab_FrameSettings_newname = key
							vexalarm_initialize(true)
							end,
						get = function() return vexalarm_optionTab_FrameSettings_currentframe end,
						},	
					space1 = {name =" ", type = "description", order=2},
					grppos = {
						name = "Position and Size",
						order=10, type ="group", dialogInline = true,
						args = {
							framewidth = {
								name = "width",
								order=1, type = "range",
								step = 1, min = 1, max = 2000,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["size"]["width"]=val vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_returnDesign("width") end
								},
							frameheight = {
								name = "height",
								order=2, type = "range",
								step = 1, min = 1, max = 2000,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["size"]["height"]=val vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_returnDesign("height") end
								},
							space1 = {name =" ", type = "description", order=3},
							frame_pos_x = {
								name = "X Position",
								order=10, type = "range",
								step = 1, min = -2000, max = 2000,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["position"]["bg"]["x"]=val vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_returnDesign("x") end
								},
							frame_pos_y = {
								name = "Y Position",
								order=11, type = "range",
								step = 1, min = -2000, max = 2000,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["position"]["bg"]["y"]=val vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_returnDesign("y") end
								},
							space2 = {name =" ", type = "description", order=12},
							frameanchor = {
								name = "Anchor Frame",
								order=20, type = "select", style = "dropdown",
								values = {
									["CENTER"]="Center",
									["BOTTOM"]="Bottom",
									["TOP"]="Top",
									["LEFT"]="Left",
									["RIGHT"]="Right",
									["BOTTOMLEFT"]="Bottom Left",
									["BOTTOMRIGHT"]="Bottom Right",
									["TOPLEFT"]="Top Left",
									["TOPRIGHT"]="Top Right"},
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["position"]["bg"]["anchor"]=key vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_returnDesign("anchor1") end,
								},
							screenanchor = {
								name = "Anchor Screen",
								order=21, type = "select", style = "dropdown",
								values = {
									["CENTER"]="Center",
									["BOTTOM"]="Bottom",
									["TOP"]="Top",
									["LEFT"]="Left",
									["RIGHT"]="Right",
									["BOTTOMLEFT"]="Bottom Left",
									["BOTTOMRIGHT"]="Bottom Right",
									["TOPLEFT"]="Top Left",
									["TOPRIGHT"]="Top Right"},
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["position"]["bg"]["frameanchor"]=key vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_returnDesign("anchor2") end,
								},
							},
						},
					frame_space1 = {name ="\n", type = "description", order=11},
						
					grpbg = {
						name = "Background",
						order=12, type ="group", dialogInline = true,
						args = {
							framebackdrop = {
								name = "Texture",
								order=1, type = "select",
								dialogControl = "LSM30_Background",
								values = vexalarm.LSM:HashTable("background"),
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["bg"]["texture"]=key vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_returnDesign("bgtexture") end,
								},
							bg_space = {name =" ", type = "description", order=2},
							framebgcolor = {
								name = "Color",
								order=3, type = "color", hasAlpha = false, width="double",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,r,g,b,a)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["bg"]["color"]["r"]=r
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["bg"]["color"]["g"]=g
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["bg"]["color"]["b"]=b
									vexalarm.testmode_recolor = true
									vexalarm_initialize(true) end,
								get = function() return
									vexalarm_optionTab_FrameSettings_returnDesign("bgcolor", "r"),
									vexalarm_optionTab_FrameSettings_returnDesign("bgcolor", "g"),
									vexalarm_optionTab_FrameSettings_returnDesign("bgcolor", "b") end,
								},
							framebgopacity = {
								name = "Opacity %",
								order=4, type = "range",
								step = 5, min = 0, max = 100,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["bg"]["color"]["a"]=val/100
									vexalarm.testmode_recolor = true
									vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_returnDesign("bgcolor", "a")*100 end
								},
							},
						},
					frame_space2 = {name ="\n", type = "description", order=13},
						
					grpborder = {
						name = "Border",
						order=14, type ="group", dialogInline = true,
						args = {
							bordertexture = {
								name = "Texture",
								order=1, type = "select",
								dialogControl = "LSM30_Border",
								values = vexalarm.LSM:HashTable("border"),
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["border"]["texture"]=key
									vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_returnDesign("bordert") end,
								},
							space1 = {name =" ", type = "description", order=2},
							bordersize = {
								name = "Size",
								order=10, type = "range",
								step = 1, min = 0, max = 100,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["border"]["size"]=val vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_returnDesign("borders") end,
								},
							space2 = {name =" ", type = "description", order=11},
							bordercolor = {
								name = "Color",
								order=20, type = "color", hasAlpha = false, width="double",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,r,g,b,a)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["border"]["color"]["r"]=r
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["border"]["color"]["g"]=g
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["border"]["color"]["b"]=b
									vexalarm.testmode_recolor = true
									vexalarm_initialize(true) end,
								get = function() return
									vexalarm_optionTab_FrameSettings_returnDesign("borderc", "r"),
									vexalarm_optionTab_FrameSettings_returnDesign("borderc", "g"),
									vexalarm_optionTab_FrameSettings_returnDesign("borderc", "b") end,
								},
							frameborderopacity = {
								name = "Opacity %",
								order=21, type = "range",
								step = 5, min = 0, max = 100,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["border"]["color"]["a"]=val/100
									vexalarm.testmode_recolor = true
									vexalarm_initialize(true) end,
								get = function() return vexalarm_optionTab_FrameSettings_returnDesign("borderc", "a")*100 end
								},
							}
						}
					},
				},
				
				
			
			text = {
				name = "Output",
				order=40, type ="group", dialogInline = true, hidden = not(vexalarm_optionTab_FrameSettings_openTab["text"]),
				args = {
					frame = {
						name = "Frame to edit",
						order=1, type = "select", style = "dropdown",
						values =  vexalarm_optionTab_FrameSettings_getList(),
						set = function(self,key)
							vexalarm_optionTab_FrameSettings_currentframe = key
							vexalarm_optionTab_FrameSettings_newname = key
							vexalarm_initialize(true)
							end,
						get = function() return vexalarm_optionTab_FrameSettings_currentframe end,
						},	
					frame_space = {name =" ", type = "description", order=2},
					grptextformat = {
						name = "Format",
						order=3, type ="group", dialogInline = true,
						args = {
							textfont = {
								name = "Font",
								order=1, type = "select",
								dialogControl = "LSM30_Font",
								values = vexalarm.LSM:HashTable("font"),
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["text"]["font"]=key end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("font") end,
								},
							textsize = {
								name = "Size",
								order=2, type = "range",
								step = 1, min = 6, max = 20,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["text"]["size"]=val end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("size") end,
								},
							fontalign = {
								name = "Align",
								order=3, type = "select", style = "dropdown",
								values = {["LEFT"]="Left",
										["CENTER"]="Center",
										["RIGHT"]="Right"},
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["text"]["align"]=key end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("align") end,
								},
							fontoutline = {
								name = "Effect",
								order=3, type = "select", style = "dropdown",
								values = {["MONOCHROME"]="Monochrome",
											["OUTLINE"]="Outline",
											[""]="None",
											["THICKOUTLINE"]="Thickoutline"},
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["text"]["outline"]=key end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("outline") end,
								},
							},
						},
					frame_spacefont = {name ="\n", type = "description", order=4},
					grpevents = {
						name = "Position",
						order=5, type ="group", dialogInline = true,
						args = {
							alarmx = {
								name = "X Distance",
								desc = "Distance from the right and left side of the frame to the text",
								order=1, type = "range",
								step = 1, min = 1, max = 100,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["position"]["alarm"]["x"]=val vexalarm_Testmode_toggleFontFrames() end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("alarmx") end,
								},
							alarmy = {
								name = "Y Distance",
								desc = "Distance from the bottom or top of the frame to the first output",
								order=2, type = "range",
								step = 1, min = -100, max = 100,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["position"]["alarm"]["y"]=val vexalarm_Testmode_toggleFontFrames() end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("alarmy") end,
								},
							space1 = {name =" ", type = "description", order=3},
							alarmspacing = {
								name = "Separation",
								desc = "Distance between the outputs",
								order=10, type = "range",
								step = 1, min = 1, max = 100,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["position"]["alarm"]["spacing"]=val vexalarm_Testmode_toggleFontFrames() end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("alarms") end,
								},
							alarmcount = {
								name = "Maximum shown events",
								order=11, type = "range",
								step = 1, min = 1, max = 20,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["maxevents"]=val vexalarm_Testmode_toggleFontFrames() end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("maxevents") end,
								},
							alarmdownwars = {
								name = "Arrange outputs upwars, instead of downwards",
								order=12, type = "toggle", width="full",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["scrolldown"]=val vexalarm_Testmode_toggleFontFrames() end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("scrolldown") end,
								},
							},
						},
					frame_space1 = {name ="\n", type = "description", order=6},
					
					grptextcolors = {
						name = "Colors",
						order=7, type ="group", dialogInline = true,
						args = {
							statuscolor1 = {
								name = "[status_sc] active",
								order=1, type = "color", width="",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,r,g,b)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["active"]["HEX"] = vexalarm_dec2hex(r,g,b)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["active"]["r"] = r
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["active"]["g"] = g
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["active"]["b"] = b end,
								get = function() return
									vexalarm_optionTab_FrameSettings_returnOutPuts("status_sca", "r"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("status_sca", "g"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("status_sca", "b") end,
								},
							statusmsgcolor1 = {
								name = "text color for buff gained/spell casted",
								order=2, type = "color", width="double",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,r,g,b,a)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["text"]["color"]["active"]["r"] = r
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["text"]["color"]["active"]["g"] = g
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["text"]["color"]["active"]["b"] = b end,
								get = function() return
									vexalarm_optionTab_FrameSettings_returnOutPuts("colorg", "r"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("colorg", "g"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("colorg", "b")end,
								},
							statuscolor2 = {
								name = "[status_sc] inactive",
								order=3, type = "color",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,r,g,b)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["inactive"]["HEX"] = vexalarm_dec2hex(r,g,b)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["inactive"]["r"] = r
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["inactive"]["g"] = g
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["inactive"]["b"] = b end,
								get = function() return
									vexalarm_optionTab_FrameSettings_returnOutPuts("status_sci", "r"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("status_sci", "g"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("status_sci", "b") end,
								},
							statusmsgcolor2 = {
								name = "text color for buff lost",
								order=4, type = "color", width="double",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,r,g,b,a)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["text"]["color"]["inactive"]["r"] = r
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["text"]["color"]["inactive"]["g"] = g
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["text"]["color"]["inactive"]["b"] = b end,
								get = function() return
									vexalarm_optionTab_FrameSettings_returnOutPuts("colorf", "r"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("colorf", "g"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("colorf", "b") end,
								},
							frame_textspace3 = {name ="\n\n", type = "description", order=5},
							
							castercolor = {
								name = "[caster_sc]",
								order=6, type = "color", width="full",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,r,g,b)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["caster_sc"]["HEX"] = vexalarm_dec2hex(r,g,b)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["caster_sc"]["r"] = r
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["caster_sc"]["g"] = g
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["caster_sc"]["b"] = b end,
								get = function() return
									vexalarm_optionTab_FrameSettings_returnOutPuts("caster_sc", "r"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("caster_sc", "g"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("caster_sc", "b") end,
								},
							targetcolor = {
								name = "[target_sc]",
								order=7, type = "color", width="full",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,r,g,b)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["target_sc"]["HEX"] = vexalarm_dec2hex(r,g,b)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["target_sc"]["r"] = r
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["target_sc"]["g"] = g
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["target_sc"]["b"] = b end,
								get = function() return
									vexalarm_optionTab_FrameSettings_returnOutPuts("target_sc", "r"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("target_sc", "g"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("target_sc", "b") end,
								},
							spellcolor = {
								name = "[spell_sc]",
								order=8, type = "color", width="full",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,r,g,b)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["spell_sc"]["HEX"] = vexalarm_dec2hex(r,g,b)
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["spell_sc"]["r"] = r
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["spell_sc"]["g"] = g
									vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["colors"]["spell_sc"]["b"] = b end,
								get = function() return
									vexalarm_optionTab_FrameSettings_returnOutPuts("spell_sc", "r"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("spell_sc", "g"),
									vexalarm_optionTab_FrameSettings_returnOutPuts("spell_sc", "b") end,
								},
						
							},
						},
					frame_space2 = {name ="\n", type = "description", order=8},
					
					grptimedata = {
						name = "Timedata",
						order=9, type ="group", dialogInline = true,
						args = {
							allowvanish = {
								name = "Activate 'fade-out'-effect",
								order=1, type = "toggle", width="full",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["timedata"]["allowvanish"]=val end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("allowvanish") end,
								},
							timedataspace = {name =" ", type = "description", order=2},
							alarmshowtime = {
								name = "Duration: message shown",
								order=2, type = "range",
								step = 1, min = 1, max = 10,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["timedata"]["show"]=val end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("tdshow") end,
								},
							alarmvanishtime = {
								name = "Duration: 'fade-out'-effect",
								order=3, type = "range",
								step = 1, min = 1, max = 10,
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["timedata"]["vanish"]=val end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("tdvanish") end,
								},
							},
						},
					frame_space3 = {name ="\n", type = "description", order=10},
					
					grpdeirmode = {
						name = "'DEIR'-Mode",
						order=11, type ="group", dialogInline = true,
						args = {
							moveuptext = {name ="In 'DEIR'-mode (Dead Events in Idle Rotatestate) the events don't move up anymore when an event-message which is displayed above them expired. They stay at their location where they are first shown.", type = "description", order=123, fontSize="medium"},
							allowmoveup = {
								name = "Activate",
								order=123, type = "toggle", width="full",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["design"]["allowscrolling"]=not(val) end,
								get = function() return vexalarm_optionTab_FrameSettings_returnOutPuts("allowscrolling") end,
								},
							}
						}
					},
				},
				
				
			
			sounds = {
				name = "Sounds",
				order=50, type ="group", dialogInline = true, hidden = not(vexalarm_optionTab_FrameSettings_openTab["sounds"]),
				args = {
					frame = {
						name = "Frame to edit",
						order=1, type = "select", style = "dropdown",
						values =  vexalarm_optionTab_FrameSettings_getList(),
						set = function(self,key)
							vexalarm_optionTab_FrameSettings_currentframe = key
							vexalarm_optionTab_FrameSettings_newname = key
							vexalarm_initialize(true)
							end,
						get = function() return vexalarm_optionTab_FrameSettings_currentframe end,
						},	
					space1 = {name =" ", type = "description", order=2},
					grpallow = {
						name = "General Settings",
						order=10, type ="group", dialogInline = true,
						args = {
							allowsounds = {
								name = "Allow Sounds",
								order=1, type = "toggle",
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(info,val) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["sounds"]["allow"]=val end,
								get = function() return vexalarm_optionTab_FrameSettings_returnSounds("allow") end,
								},
							},
						},
					space2 = {name ="\n", type = "description", order=11},
					grpactive = {
						name = "Buff gained",
						order=20, type ="group", dialogInline = true,
						args = {
							buff_activesound = {
								name = "Sound",
								order=11, type = "select",
								dialogControl = "LSM30_Sound",
								values = vexalarm.LSM:HashTable("sound"),
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["sounds"]["active"]["file"] = key end,
								get = function() return vexalarm_optionTab_FrameSettings_returnSounds("file1") end,
								},
							buff_activesoundchannel = {
								name = "Channel",
								order=12, type = "select", style = "dropdown",
								values = {["Master"]="Master", ["SFX"]="SFX", ["Ambience"]="Ambience", ["Music"]="Music"},
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["sounds"]["active"]["channel"] = key  end,
								get = function() return vexalarm_optionTab_FrameSettings_returnSounds("channel1") end,
								},
							},
						},
					space3 = {name ="\n", type = "description", order=21},
					grpinactive = {
						name = "Buff lost",
						order=30, type ="group", dialogInline = true,
						args = {
							buff_inactivesound = {
								name = "Sound",
								order=21, type = "select",
								dialogControl = "LSM30_Sound",
								values = vexalarm.LSM:HashTable("sound"),
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["sounds"]["inactive"]["file"] = key end,
								get = function() return vexalarm_optionTab_FrameSettings_returnSounds("file2") end,
								},
							buff_inactivesoundchannel = {
								name = "Channel",
								order=22, type = "select", style = "dropdown",
								values = {["Master"]="Master", ["SFX"]="SFX", ["Ambience"]="Ambience", ["Music"]="Music"},
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["sounds"]["inactive"]["channel"] = key end,
								get = function() return vexalarm_optionTab_FrameSettings_returnSounds("channel2") end,
								},
							},
						},
					space4 = {name ="\n", type = "description", order=31},
					grpcast = {
						name = "Spell without buff casted",
						order=40, type ="group", dialogInline = true,
						args = {
							inactivesound = {
								name = "Sound",
								order=21, type = "select",
								dialogControl = "LSM30_Sound",
								values = vexalarm.LSM:HashTable("sound"),
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["sounds"]["cast"]["file"] = key end,
								get = function() return vexalarm_optionTab_FrameSettings_returnSounds("file3") end,
								},
							inactivesoundchannel = {
								name = "Channel",
								order=22, type = "select", style = "dropdown",
								values = {["Master"]="Master", ["SFX"]="SFX", ["Ambience"]="Ambience", ["Music"]="Music"},
								disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["sounds"]["cast"]["channel"] = key end,
								get = function() return vexalarm_optionTab_FrameSettings_returnSounds("channel3") end,
								},
							},
						},
					},
				},
				
				
			
			show = {
				name = "Show",
				order=60, type ="group", dialogInline = true, hidden = not(vexalarm_optionTab_FrameSettings_openTab["show"]),
				args = {
					frame = {
						name = "Frame to edit",
						order=1, type = "select", style = "dropdown",
						values =  vexalarm_optionTab_FrameSettings_getList(),
						set = function(self,key)
							vexalarm_optionTab_FrameSettings_currentframe = key
							vexalarm_optionTab_FrameSettings_newname = key
							vexalarm_initialize(true)
							end,
						get = function() return vexalarm_optionTab_FrameSettings_currentframe end,
						},	
					frame_space = {name =" ", type = "description", order=2},
					grpshow = {
						name = "Settings",
						order=3, type ="group", dialogInline = true,
						args = {
							infightFrame = {
								name = "Hide frame when not infight",
								order=1, type = "toggle", width="full",
										disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["show"]["showFrameonlyinfight"]=key vexalarm_Proclaims_checkShow() end,
								get = function() return vexalarm_optionTab_FrameSettings_returnShow("showFrameonlyinfight") end,
								},
							soace = {name =" ", type = "description", order=2},
							infight = {
								name = "Only track spells/buffs when infight",
								order=10, type = "toggle", width="full",
										disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["show"]["showonlyinfight"]=key vexalarm_Proclaims_checkShow() end,
								get = function() return vexalarm_optionTab_FrameSettings_returnShow("showonlyinfight") end,
								},
							grp = {
								name = "Only track spells/buffs from grp/raid members",
								order=11, type = "toggle", width="full",
										disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["show"]["showgrponly"]=key end,
								get = function() return vexalarm_optionTab_FrameSettings_returnShow("showgrponly") end,
								},
							myspells = {
								name = "Only track spells/buffs I didn't cast myself",
								order=12, type = "toggle", width="full",
										disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_FrameSettings_getList(), vexalarm_optionTab_FrameSettings_currentframe),
								set = function(self,key) vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]["show"]["myspells"]=not(key) end,
								get = function() return not(vexalarm_optionTab_FrameSettings_returnShow("myspells")) end,
								}
							},
						},
					},
				},
			}
		}
end








