function vexalarm.panel_spellprofiles()	
	return {
		type = "group",
		args = {
			grpsave = {
				name = "Save",
				order=1, type ="group", dialogInline = true,
				args = {
					addName = {
						name = "Name",
						order=1, type = "input", width="double",
						set = function(info,val) vexalarm_optionTab_SpellProfiles_name = val vexalarm_initialize(true) end,
						get = function() return vexalarm_optionTab_SpellProfiles_name end,
						},
					addButton = {
						name = "save",
						order=2, type = "execute",
						disabled = not(vexalarm_optionTab_General_checkName(vexalarm_optionTab_SpellProfiles_name)),
						func = function(info,val) vexalarm_optionTab_SpellProfiles_save() vexalarm_initialize(true) end,
						confirm = vexalarm_sp[vexalarm_optionTab_SpellProfiles_name]~= nil,
						confirmText = "A Spellprofile with that name allready exists. Do you want to overwrite it ?",
						},
					status = {name = vexalarm_optionTab_SpellProfiles_statusMsg["save"], type = "description", order=4},
					},
				},
			space1 = {name = " ", type = "description", order=2},
			grpdelete = {
				name = "Load, delete, rename, send",
				order=3, type ="group", dialogInline = true,
				args = {
					profile = {
						name = "Existing spell-profiles",
						order=1, type = "select", style = "dropdown", width="double",
						values = vexalarm_optionTab_SpellProfiles_getList(false, true),
						set = function(self,key)
							vexalarm_optionTab_SpellProfiles_profile = key
							vexalarm_optionTab_SpellProfiles_newname = key
							vexalarm_initialize(true)
							end,
						get = function() return vexalarm_optionTab_SpellProfiles_profile end,
						},
					load_exe = {
						name = "load",
						order=3, type = "execute", width="half",
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_SpellProfiles_getList(), vexalarm_optionTab_SpellProfiles_profile),
						func = function(info,val) vexalarm_optionTab_SpellProfiles_load() vexalarm_initialize(true) end,
						},
					delete_exe = {
						name = "delete",
						order=4, type = "execute", width="half",
						func = function(info,val) vexalarm_optionTab_SpellProfiles_delete() vexalarm_initialize(true) end,
						confirm = true,
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_SpellProfiles_getList(), vexalarm_optionTab_SpellProfiles_profile),
						confirmText = "Do you really want to delete this spell-profile?"
						},
					load_info = {name = "You can also load spell-profiles with slash-commands\n'/vexalarm profile X' - loads the spell-profile 'X'\n", type = "description", order=9},
					status_load = {name = vexalarm_optionTab_SpellProfiles_statusMsg["load"], type = "description", order=10},
					newname = {
						name = "New name",
						order=11, type = "input", width="double",
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_SpellProfiles_getList(), vexalarm_optionTab_SpellProfiles_profile),
						set = function(info,val) vexalarm_optionTab_SpellProfiles_newname = val vexalarm_initialize(true) end,
						get = function() return vexalarm_optionTab_SpellProfiles_newname end,
						},
					changename = {
						name = "change name",
						order=13, type = "execute", 
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_SpellProfiles_getList(), vexalarm_optionTab_SpellProfiles_profile) or vexalarm_optionTab_SpellProfiles_newname=="",
						func = function(info,val) vexalarm_optionTab_SpellProfiles_rename() vexalarm_initialize(true) end,
						confirm = vexalarm_sp[vexalarm_optionTab_SpellProfiles_newname]~= nil,
						confirmText = "A Spellprofile with the new name allready exists. Do you want to overwrite it ?",
						},
					status_rename = {name = vexalarm_optionTab_SpellProfiles_statusMsg["rename"], type = "description", order=20},
					send_info = {name = "You can send spell-profiles to other players who also have the addon active", type = "description", order=30},
					send_target = {
						name = "Target player",
						order=31, type = "input", width="double",
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_SpellProfiles_getList(), vexalarm_optionTab_SpellProfiles_profile),
						set = function(info,val) vexalarm_optionTab_SpellProfiles_target = val vexalarm_initialize(true) end,
						get = function() return vexalarm_optionTab_SpellProfiles_target end,
						},
					send_exe = {
						name = "send",
						order=33, type = "execute",
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_SpellProfiles_getList(), vexalarm_optionTab_SpellProfiles_profile) or vexalarm_optionTab_SpellProfiles_target=="",
						func = function(info,val) vexalarm_Msgs_send() end,
						},
					status_send = {name = "A feedback whether the sending was successfull will be printed in your chat", type = "description", order=40},
					},
				},
			frame_space5 = {name =" ", type = "description", order=10},
			grpSaveReceived = {
				name = "Save a received spell-profile",
				order=11, type = "group", dialogInline = true,
				args = {
					received_profile_load = {
						name = "received spell-profiles",
						order=1, type = "select", style = "dropdown",
						values = vexalarm_optionTab_SpellProfiles_recSPGetList(),
						set = function(self,key)
							vexalarm_optionTab_SpellProfiles_RecSP = key
							vexalarm_optionTab_SpellProfiles_RecSP_newname = vexalarm.incomeSpellProfiles[key]["name"]
							vexalarm_initialize(true)
							end,
						get = function() return vexalarm_optionTab_SpellProfiles_RecSP end,
						},
					received_profile_name = {
						name = "name",
						order=2, type = "input", multiline = false,
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_SpellProfiles_recSPGetList(), vexalarm_optionTab_SpellProfiles_RecSP),
						set = function(info,val) vexalarm_optionTab_SpellProfiles_RecSP_newname = val vexalarm_initialize(true) end,
						get = function() return vexalarm_optionTab_SpellProfiles_RecSP_newname end,
						},
					received_load_exe = {
						name = "save",
						order=3, type = "execute",
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_SpellProfiles_recSPGetList(), vexalarm_optionTab_SpellProfiles_RecSP),
						func = function(info,val) vexalarm_optionTab_SpellProfiles_recSPSave() vexalarm_initialize(true) end,
						confirm = vexalarm_sp[vexalarm_optionTab_SpellProfiles_RecSP_newname]~= nil,
						confirmText = "A Spellprofile with that name allready exists. Do you want to overwrite it ?",
						},
					status = {name = vexalarm_optionTab_SpellProfiles_statusMsg["saveRe"], type = "description", order=4},
					},
				},
			}
		}
end